Unit QTSXR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QTSXR(var RINT :Array of Real; var X1 :Array of Real;
                var X2 :Array of Real; var F :Array of Real;
                N :Integer; M :Integer);

implementation

procedure QTSXR(var RINT :Array of Real; var X1 :Array of Real;
                var X2 :Array of Real; var F :Array of Real;
                N :Integer; M :Integer);
var
I,J :Integer;
A,A1,A3,A4,A5,B,B11,B12,B13,B14,B21,B22,B23,B24,C,C1,C2,C3,C4,C5,D1,
   D2,D3,F12,RA2 :Real;
A2 :Array [0..3] of Real;
label
_10,_20,_30,_40,_50,_60,_70;
{  -  FORTRAN }
function AR(R1: Real; R2: Real; R3: Real; R4: Real): Real;
begin
Result := B11*R1 + B12*R2 + B13*R3 + B14*R4;
end;
function AP(R1: Real; R2: Real; R3: Real; R4: Real): Real;
begin
Result := B21*R1 + B22*R2 + B23*R3 + B24*R4;
end;
{   - }
begin
A := X2[1] - X2[0];
C5 := A/6.0;
B11 := (X2[1] - A)*(X2[2] - A)*(X2[3] - A)/((X2[1]-X2[0])*
    (X2[2] - X2[0])*(X2[3] - X2[0]));
B12 := (X2[0] - A)*(X2[2] - A)*(X2[3] - A)/((X2[0]-X2[1])*
    (X2[2] - X2[1])*(X2[3] - X2[1]));
B13 := (X2[0] - A)*(X2[1] - A)*(X2[3] - A)/((X2[0]-X2[2])*
    (X2[1] - X2[2])*(X2[1] - X2[3]));
B14 := (X2[0] - A)*(X2[1] - A)*(X2[2] - A)/((X2[0]-X2[3])*
    (X2[1] - X2[3])*(X2[2] - X2[3]));
A := X1[1] - X1[0];
B21 := (X1[1] - A)*(X1[2] - A)*(X1[3] - A)/((X1[1]-X1[0])*
    (X1[2] - X1[0])*(X1[3] - X1[0]));
B22 := (X1[0] - A)*(X1[2] - A)*(X1[3] - A)/((X1[0]-X1[1])*
    (X1[2] - X1[1])*(X1[3] - X1[1]));
B23 := (X1[0] - A)*(X1[1] - A)*(X1[3] - A)/((X1[0]-X1[2])*
    (X1[1] - X1[2])*(X1[1] - X1[3]));
B24 := (X1[0] - A)*(X1[1] - A)*(X1[2] - A)/((X1[0]-X1[3])*
    (X1[1] - X1[3])*(X1[2] - X1[3]));
C4 := A/6.0;
C := C5*C4;
for J:=1 to 4 do
 begin
  A2[J-1] := AP(F[0+(J-1)*N],F[1+(J-1)*N],F[2+(J-1)*N],F[3+(J-1)*N]);
_10:
 end;
F12 := AR(A2[0],A2[1],A2[2],A2[3]);
A3 := AR(F[0+0*N],F[0+1*N],F[0+2*N],F[0+3*N]);
A4 := AR(F[1+0*N],F[1+1*N],F[1+2*N],F[1+3*N]);
RINT[1+1*N] := (F[0+0*N] + F[1+0*N] + F[0+1*N] + F[1+1*N] + 16.0*F12 +
    4.0*(A3 + A4 + A2[0] + A2[1]))*C;
for J:=1 to M do
 begin
  RINT[0+(J-1)*N] := 0.0;
_20:
 end;
RINT[1+0*N] := 0.0;
A1 := X2[1] - X2[0];
for J:=3 to M do
 begin
  A := X2[J-1] - X2[J-3];
  RA2 := X2[J-1] - X2[J-2];
  B := A*A/6.0;
  C1 := -B/A1 + A/2.0;
  C2 := (A*B)/(RA2*A1);
  C3 := (2.0*B - A*A1/2.0)/RA2;
  A2[2] := AP(F[0+(J-1)*N],F[1+(J-1)*N],F[2+(J-1)*N],F[3+(J-1)*N]);
  RINT[1+(J-1)*N] := RINT[1+(J-3)*N] + ((F[0+(J-3)*N]+4.0*A2[0] + F[1+(J-3)*N]
    )*C1 + C2*(F[0+(J-2)*N] + 4.0*A2[1] + F[1+(J-2)*N]
    ) + C3*(F[0+(J-1)*N] + 4.0*A2[2] + F[1+(J-1)*N]))*C4;
  A2[0] := A2[1];
  A2[1] := A2[2];
  A1 := RA2;
_30:
 end;
A1 := X1[1] - X1[0];
for I:=3 to N do
 begin
  A := X1[I-1] - X1[I-3];
  RA2 := X1[I-1] - X1[I-2];
  B := A*A/6.0;
  D1 := -B/(A1) + A/2.0;
  D2 := (A*B)/(RA2*A1);
  D3 := (2.0*B - A*A1/2.0)/RA2;
  A5 := AR(F[(I-1)+0*N],F[(I-1)+1*N],F[(I-1)+2*N],F[(I-1)+3*N]);
  RINT[(I-1)+0*N] := 0.0;
  RINT[(I-1)+1*N] := ((F[(I-3)+0*N]+4.0*A3+F[(I-3)+1*N])*D1 + D2*(F[(I-2)+0*N]
    + 4.0*A4 + F[(I-2)+1*N]) + D3*(F[(I-1)+0*N] + 4.0*A5 +
    F[(I-1)+1*N]))*C5;
  A3 := A4;
  A4 := A5;
  A1 := X2[1] - X2[0];
  for J:=3 to M do
   begin
    A := X2[J-1] - X2[J-3];
    F12 := X2[J-1] - X2[J-2];
    B := A*A/6.0;
    C1 := -B/A1 + A/2.0;
    C2 := (A*B)/(F12*A1);
    C3 := (2.0*B - A*A1/2.0)/F12;
    RINT[(I-1)+(J-1)*N] := RINT[(I-1)+(J-3)*N] + D1*(C1*F[(I-3)+(J-3)*N] + C2*
    F[(I-3)+(J-2)*N] + C3*F[(I-3)+(J-1)*N]) + D2*(C1*F[(I-1-1)+(
    J-2-1)*N] + C2*F[(I-2)+(J-2)*N] + C3*F[(I-2)+(J-1)*N]) + D3*
    (F[(I-1)+(J-3)*N]*C1 + C2*F[(I-1)+(J-2)*N] + C3*F[(I-1)+(J-1)*N]);
    A1 := F12;
_40:
   end;
  A1 := RA2;
_50:
 end;
for I:=3 to N do
 begin
  for J:=3 to M do
   begin
    RINT[(I-1)+(J-1)*N] := RINT[(I-1)+(J-1)*N] + RINT[(I-3)+(J-1)*N];
_60:
   end;
_70:
 end;
end;

end.
